#include "testlib.h"

using namespace std;

struct Point {
	long long x, y;
	
	Point() {}
	Point(long long _x, long long _y) : x(_x), y(_y) {}
	
	Point operator+ (const Point &a) {
		return Point(x + a.x, y + a.y);
	}
	
	Point operator- (const Point &a) {
		return Point(x - a.x, y - a.y);
	}
	
	long long operator^ (const Point &a) {
		return x * a.y - y * a.x;
	}
};

int main(int argc, char* argv[]) {
	registerValidation(argc, argv);
	
	int n = inf.readInt(3, 100'000, "n");
	inf.readEoln();
	vector <Point> p(n);
	for (int i = 0; i < n; i++) {
		p[i].x = inf.readInt(-1'000'000'000, 1'000'000'000, "xi");
		inf.readSpace();
		p[i].y = inf.readInt(-1'000'000'000, 1'000'000'000, "yi");
		inf.readEoln();
	}
	
	p.push_back(p[0]);
	p.push_back(p[1]);
	for (int i = 0; i < n; i++)
		ensuref(((p[i + 1] - p[i]) ^ (p[i + 2] - p[i + 1])) > 0, "not in ccw order or not convex");

	inf.readEof();
	
	return 0;
}