#include <iostream>
#include <vector>
#include <cmath>
#include <iomanip>

#define sqr(x) ((x)*(x))

using namespace std;

const double EPS = 1e-7;

struct Point {
	long long x, y;
	
	Point() {}
	Point(long long _x, long long _y) : x(_x), y(_y) {}
	
	Point operator- (const Point &a) {
		return Point(x - a.x, y - a.y);
	}
	
	long long dist2() {
		return sqr(x) + sqr(y);
	}
	
	double dist() {
		return sqrt(dist2());
	}
};

int main() {
	int n;
	cin >> n;
	
	Point prev, f;
	vector <double> dists;
	for (int i = 0; i < n; i++) {
		Point p;
		cin >> p.x >> p.y;
		if (i == 0) f = p;
		else dists.push_back((p - prev).dist());
		prev = p;
	}
	
	dists.push_back((f - prev).dist());
	double ans = 1e10;
	
	for (int i = 0; i < n; i++) {
		double cur = 0;
		for (int j = 0; j < n; j++)
			if (i != j) cur += dists[j];
		if (ans - EPS > cur) ans = cur;
	}
	
	cout.precision(9);
	cout << fixed << ans;
	
	return 0;
}