#include "testlib.h"
#include <vector>

using namespace std;

bool dfs(vector <vector <int>>& g, int v, int& cnt) {
	cnt++;
	if (g[v].size() > 2)
		return false;
	bool ret = true;
	for (auto to : g[v])
		ret &= dfs(g, to, cnt);
	return ret;
}

int main(int argc, char* argv[]) {
	registerValidation(argc, argv);
	
	int n = inf.readInt(2, 1'000, "n");
	inf.readEoln();
	
	vector <vector <int>> ga(n);
	for (int i = 0; i < n - 1; i++) {
		int pai = inf.readInt(0, n - 1, "pai");
		ensuref(pai != i + 1, "no loops");
		
		ga[pai].push_back(i + 1);
		
		if (i == n - 2) inf.readEoln();
		else inf.readSpace();
	}
	int cnta = 0;
	ensuref(dfs(ga, 0, cnta), "first one is not binary");
	ensuref(cnta == n, "first one is not connected");
	
	vector <vector <int>> gb(n);
	for (int i = 0; i < n - 1; i++) {
		int pbi = inf.readInt(0, n - 1, "pbi");
		ensuref(pbi != i + 1, "no loops");
		
		gb[pbi].push_back(i + 1);
		
		if (i == n - 2) inf.readEoln();
		else inf.readSpace();
	}
	int cntb = 0;
	ensuref(dfs(gb, 0, cntb), "second one is not binary");
	ensuref(cntb == n, "second one is not connected");
	
	inf.readEof();
	
	return 0;
}