#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

pair <int, int> to_bamboo(vector <vector <int>>& g, vector <vector <int>>& ans, vector <int>& ord, int v = 0) {
	ord.push_back(v);
	if (g[v].size() == 0) return {v, v};
	if (g[v].size() == 1) return {v, to_bamboo(g, ans, ord, g[v][0]).second};
	auto p1 = to_bamboo(g, ans, ord, g[v][0]);
	auto p2 = to_bamboo(g, ans, ord, g[v][1]);
	ans.push_back({ p2.first, p1.second, v });
	return {v, p2.second};
}

int main() {
	int n;
	cin >> n;
	
	vector <vector <int>> ga(n), gb(n);
	for (int i = 1; i < n; i++) {
		int pai;
		cin >> pai;
		ga[pai].push_back(i);
	}
	for (int i = 1; i < n; i++) {
		int pbi;
		cin >> pbi;
		gb[pbi].push_back(i);
	}
	
	vector <vector <int>> ans1, ans2;
	vector <int> ord1, ord2;
	to_bamboo(ga, ans1, ord1);
	to_bamboo(gb, ans2, ord2);
	
	vector <int> b_to_a(n);
	for (int i = 0; i < n; i++)
		b_to_a[ord2[i]] = ord1[i];
	
	cout << ans1.size() + ans2.size() << '\n';
	for (auto cur : ans1)
		cout << cur[0] << ' ' << cur[1] << '\n';
	
	reverse(ans2.begin(), ans2.end());
	for (auto cur : ans2)
		cout << b_to_a[cur[0]] << ' ' << b_to_a[cur[2]] << '\n';
	
	return 0;
}
	